#!/bin/sh

echo This shellscript was used to reorganize the mpeg4sls project to the common structure of the refsoft.
echo Moreover it does changes to the local cvs Repository with add/remove new/old files when being run.


#function to remove all entrys of a directory from the cvs-repository and remove the folder itself locally (in future if the repository is checked out/updated  with the -P (prune) option, empty folders won't appear in your local copy)

basepath=`pwd`
echo $basepath

rmfilescvs() {
    cd $1
    files=`find . ! -name . -prune -type f`
    for i in $files; do
        echo "I will be removed `pwd` $i"
       rm $i
       cvs remove $i
    done
    cd $basepath   
}

addfilescvs(){
    cd $1
    files=`find . ! -name . -prune -type f`
    for i in $files; do
        cvs add $i 
        echo "I will be added `pwd` $i"
    done
    cd $basepath 
}

##########################################################
# Remove currently not used sources as:


# Remove all files in the BstTruncation folder from the repository and delete the folder
rmfilescvs BstTruncation

# Remove all files in the import folder from the repository and delete the folder
rmfilescvs import

#the whole make folder, as the makefiles are substituted by a new one, based on the lauber makefiles
#therefore none in the folder "make" is needed anymore
rmfilescvs make

#remove the makefile in the tables_enc folder which appears to be a copy of the makefile of the SLS_enc
cvs remove -f ./tables_enc/makefile

#clearup the dec folder, delete files which weren't linked in the makefile, or which had a non valid syntax
cvs remove -f ./dec/adif2mp4.c
cvs remove -f ./dec/aac.c

#############################################################
# Create new folder structure and add them to the repository


# src folders for the encoder
# mkdir src_enc
#cvs add src_enc #folder already added

# mkdir src_enc_bsac
#cvs add src_enc_bsac #folder already added

# mkdir src_enc_mp4
#cvs add src_enc_mp4 #folder already added

# src folders for the decoder
# mkdir src_dec
#cvs add src_dec #folder already added

# mkdir src_dec_bsac
#cvs add src_dec_bsac #folder already added

# mkdir src_dec_mp4
#cvs add src_dec_mp4 #folder already added

# documentary 
# mkdir doc 
#cvs add doc #folder already added


#############################################################
# Copy and move the files to their destinations

# Changes the folder structure to the std. Structure of the refsoft consiting of:
# src_enc
cp ./enc/*.* ./src_enc/
#addfilescvs ./src_enc/ #will be added in the end as files will be renamed

cp ./enc/BSAC/*.* ./src_enc_bsac/
#addfilescvs ./src_enc_bsac/ #will be added in the end as files will be renamed

# src_dec
cp ./dec/*.* ./src_dec/
#addfilescvs ./src_dec/ #will be added in the end as files will be renamed

rm ./dec/BSAC/port.h
cvs remove /dec/BSAC/port.h

cp ./dec/BSAC/*.* ./src_dec_bsac/
#addfilescvs ./src_dec_bsac/ #will be added in the end as files will be renamed

# doc
mv updates.txt ./doc/
mv usage.txt ./doc/
mv readme.txt ./doc/


# remove the old doc files
cvs remove updates.txt
cvs remove usage.txt
cvs remove readme.txt

# move the MP4container to seperate folders and rename the files
cp ./MP4container/* ./src_dec_mp4/
cp ./MP4container/* ./src_enc_mp4/ 

mv ./src_dec_mp4/MP4moviewrapper.c ./src_dec_mp4/MP4moviewrapper_dec.c
mv ./src_dec_mp4/MP4moviewrapper.h ./src_dec_mp4/MP4moviewrapper_dec.h
#addfilescvs ./src_dec_mp4/ #will be added in the end as files will be renamed

mv ./src_enc_mp4/MP4moviewrapper.c ./src_enc_mp4/MP4moviewrapper_enc.c
mv ./src_enc_mp4/MP4moviewrapper.h ./src_enc_mp4/MP4moviewrapper_enc.h
#addfilescvs ./src_enc_mp4/ #will be added in the end as files will be renamed


#############################################################
# Delete old folders and removing all the files in the folders from the cvs

rmfilescvs ./enc
rmfilescvs ./enc/BSAC

rmfilescvs ./dec
rmfilescvs ./dec/BSAC

rmfilescvs ./MP4container





##################################################################
# Rename files and replace the name of the files in the corresponding src files

sed -e "s,../MP4container/MP4moviewrapper.h,MP4moviewrapper_enc.h,g" "./src_enc/encoder.c" > "./src_enc/encoder.tmp" 
mv -f "./src_enc/encoder.tmp" "./src_enc/encoder.c"

sed -e "s,../MP4container/MP4moviewrapper.h,MP4moviewrapper_dec.h,g" "./src_dec/decoder.c" > "./src_dec/decoder.tmp" 
mv -f "./src_dec/decoder.tmp" "./src_dec/decoder.c"

sed -e "s,MP4moviewrapper.h,MP4moviewrapper_enc.h,g" "./src_enc_mp4/MP4moviewrapper_enc.c" > "./src_enc_mp4/MP4moviewrapper_enc.tmp" 
mv -f "./src_enc_mp4/MP4moviewrapper_enc.tmp" "./src_enc_mp4/MP4moviewrapper_enc.c"

sed -e "s,MP4moviewrapper.h,MP4moviewrapper_dec.h,g" "./src_dec_mp4/MP4moviewrapper_dec.c" > "./src_dec_mp4/MP4moviewrapper_dec.tmp" 
mv -f "./src_dec_mp4/MP4moviewrapper_dec.tmp" "./src_dec_mp4/MP4moviewrapper_dec.c"

sed -e "s,BSAC/allHandles.h,allHandles.h,g" "./src_dec/adifdec.c" > "./src_dec/adifdec.tmp" 
mv -f "./src_dec/adifdec.tmp" "./src_dec/adifdec.c"

#The Filenames which are equally in the src_dec and src_dec_bsac folders should be renamed for clarification    
equalfilenamesbsac=( all.h block.h interface.h monopred.h nok_ltp_common.h tf_main.h tns.h)

echo The following files will be replaced to *_bsac
echo $equalfilenamesbsac

#Make a File to log the changes done to the Files
echo "The file changes.log describes the changes done in the Directory"

#Step through the file Array of equal named files
for file in ${equalfilenamesbsac[@]}; do

newfilename="${file%.*}_bsac.${file/*./}"

#Copying the file to oldfilename_enc.oldfileending
mv src_dec_bsac/$file src_dec_bsac/$newfilename
echo "Moved $file to $newfilename"

echo searching and replacing string $file to $newfilename

#Search for files in the encoder source directory which contain the old file name, and change it to the new one
for i in ./src_dec_bsac/*.*; do
  
  cp "$i" "$i".backup
    sed -e "s,\b$file\b,$newfilename,g" "$i" > "$i.tmp" 

  difference=`diff "$i".backup "$i.tmp"`
  if [ "$difference" != "" ];then 
      echo "" >> changes.log
      echo "" >> changes.log
      echo "++++++++++++++++++++" >> changes.log
      echo "Changed File $i while replacing the string $file with $newfilename" >> changes.log
      echo "$difference" >> changes.log
      echo "++++++++++++++++++++" >> changes.log   
      echo "" >> changes.log
      echo "changed file $i"
  mv -f "$i.tmp" "$i"
  rm -f "$i.tmp" 
 
  fi
  rm -f  "$i.backup"
  rm -f "$i.tmp" 
done   

done

#change back one line in the file src_dec_bsac/sam_dec.h
sed -e "s,../tns_bsac.h,../src_dec/tns.h,g" "./src_dec_bsac/sam_dec.h" > "./src_dec_bsac/sam_dec.tmp" 
mv -f "./src_dec_bsac/sam_dec.tmp" "./src_dec_bsac/sam_dec.h"

sed -e "s,../tns_bsac.h,../src_dec/tns.h,g" "./src_dec_bsac/sam_decode_frame.c" > "./src_dec_bsac/sam_decode_frame.tmp" 
mv -f "./src_dec_bsac/sam_decode_frame.tmp" "./src_dec_bsac/sam_decode_frame.c"

 
#As problems occur with equal named files in the en and decoder. Same named files in the encoder are named to *_enc.* to avoid problems with the makefile.

#The Filenames which are equally in the en and decoder 
equalfilenames=( aac_qc.h acod.c acod.h all.h block.h cbac.c cbac.h int_compact_tables.c int_mdct_defs.h int_win_dctiv.c interface.h lit_ms.c lit_ms.h nok_ltp_common.h port.h stdinc.h tf_main.h tns.c tns.h bitstream.c bitstream.h dec.h sony_local.h transfo.h)

echo The following files will be replaced
echo $equalfilenames

#Make a File to log the changes done to the Files
echo "This File describes the changes done in the Directory"

#Step through the file Array of equal named files
for file in ${equalfilenames[@]}; do


newfilename="${file%.*}_enc.${file/*./}"



#Copying the file to oldfilename_enc.oldfileending
mv src_enc/$file src_enc/$newfilename
echo "Moved $file to $newfilename"

echo searching and replacing string $file to $newfilename

#Search for files in the encoder source directory which contain the old file name, and change it to the new one
for i in ./src_enc/*.*; do
 
  cp "$i" "$i".backup
    sed -e "s,\b$file\b,$newfilename,g" "$i" > "$i.tmp" 

  difference=`diff "$i".backup "$i.tmp"`
  if [ "$difference" != "" ];then 
      echo "" >> changes.log
      echo "" >> changes.log
      echo "++++++++++++++++++++" >> changes.log
      echo "Changed File $i while replacing the string $file with $newfilename" >> changes.log
      echo "$difference" >> changes.log
      echo "++++++++++++++++++++" >> changes.log   
      echo "" >> changes.log
      echo "changed file $i"
  mv -f "$i.tmp" "$i"
  rm -f "$i.tmp" 
 
  fi
  rm -f  "$i.backup"
  rm -f "$i.tmp" 
done   

done

##################################################################
# Adding the new files to the repository

addfilescvs ./src_enc
addfilescvs ./src_enc_bsac
addfilescvs ./src_enc_mp4

addfilescvs ./src_dec
addfilescvs ./src_dec_bsac
addfilescvs ./src_dec_mp4

addfilescvs ./doc/

