#include "MP4Movies.h"

/* is set here and in port.h */
/* do not use if CURRENT bsac conformance bitstreams shall be decoded; 06.Okt.2010 */
#define SAMPLEGROUP_ELST

#define NUM_LAYERS 3+1

typedef struct
{
	MP4Movie moov;								MP4Track trak[NUM_LAYERS];					
	MP4TrackReader trackReader[NUM_LAYERS];		MP4Media media[NUM_LAYERS];			
	MP4Handle decoderSpecificInfoH[NUM_LAYERS];	MP4Handle sampleBufH[NUM_LAYERS];
	MP4Handle sampleEntryH[NUM_LAYERS];			MP4UserData udta;

#ifdef SAMPLEGROUP_ELST	
  /* for pre-roll and edit list */
  unsigned int sampleDescriptionIndex[NUM_LAYERS];
	unsigned int samplesPerFrame[NUM_LAYERS];

  unsigned int sampleBufH_size[NUM_LAYERS];
  short preRoll[NUM_LAYERS];
  unsigned int eof[NUM_LAYERS];
  double       outDuration[NUM_LAYERS];
  unsigned int firstFrame[NUM_LAYERS];
#endif  

} MP4MovieStruct;



static unsigned int sampling_rate[] = {	96000, 88200, 64000, 48000, 44100, 32000, 24000, 
                                        22050, 16000, 12000, 11025, 8000, 7350, 0, 0, 0 };
static unsigned int pcm_word_length[] = {8, 16, 20, 24, 0, 0, 0 };	/* restored 8 */
static unsigned int frame_length[] = {1024, 2048, 4096, 0, 0, 0, 0, 0 };



/* decoder-related functions */
MP4Err MP4InitMovie(MP4MovieStruct* movie, const char* MovieFileName, unsigned int *corepresent, 
					unsigned int* samplecount, unsigned int* bitrate, unsigned int* totallayers);

#ifdef SAMPLEGROUP_ELST
MP4Err MP4GetNextAUfromMovie(MP4MovieStruct* movie, 
                             unsigned char sampleBuf[][1<<16], 
                             unsigned int *sampleBufLen,
                             double* duration, 
                             unsigned int numlayers  );
#else
MP4Err MP4GetNextAUfromMovie(MP4MovieStruct* movie, unsigned int *sampleBufLen,
                                                        unsigned int* duration, unsigned int numlayers );
#endif

MP4Err MP4CloseMovie(MP4MovieStruct movie, unsigned int totalLayers);


/* encoder-related functions */
MP4Err MP4CreateNewMovie(MP4MovieStruct* movieOut, unsigned int corepresent, unsigned int samplingfreq, 
						 unsigned int AOT, unsigned int numchannels, unsigned int numbits, 
						 unsigned int OSF, unsigned int numlayers) ;

MP4Err setSLSAudioSpecificConfig(MP4Handle* AAZ_decoderSpecificConfigH, unsigned int audioObjectType, 
		unsigned int samplingFreq, unsigned int channelConfig, unsigned int pcmWordLength, 
		unsigned int corePresent,  unsigned int frameLength, unsigned int lle_main_stream);

MP4Err MP4SetNextAUintoMovie(MP4MovieStruct* movieOut, unsigned int *sampleBufLen, 
							 unsigned int duration, unsigned int numlayers);

#ifdef SAMPLEGROUP_ELST
MP4Err MP4OutputMovie(MP4MovieStruct* movieOut, const char* outfilename,  
					  unsigned int numlayers,
						const int nDelay,
						const int    sampleRateOut,
			                const int    originalSampleCount,
			                const int    originalSamplingRate
			                );
#else
MP4Err MP4OutputMovie(MP4MovieStruct* movieOut, const char* outfilename,
                                         unsigned int numlayers);
#endif


